VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TimestampedFCDescription"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

' Copyright 1995-2004 ESRI

' All rights reserved under the copyright laws of the United States.

' You may freely redistribute and use this sample code, with or without modification.

' Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED 
' WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
' FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR 
' CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
' OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
' INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY 
' THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY 
' WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF 
' SUCH DAMAGE.

' For additional information contact: Environmental Systems Research Institute, Inc.

' Attn: Contracts Dept.

' 380 New York Street

' Redlands, California, U.S.A. 92373 

' Email: contracts@esri.com

Option Explicit

Implements IObjectClassDescription
Implements IFeatureClassDescription
Const c_sShapeFieldName As String = "Shape"
 
Private Property Get IObjectClassDescription_Name() As String
  IObjectClassDescription_Name = "Timestamped Feature Class"
End Property
 
Private Property Get IObjectClassDescription_AliasName() As String
  IObjectClassDescription_AliasName = ""
End Property
 
Private Property Get IObjectClassDescription_ModelName() As String
  IObjectClassDescription_ModelName = ""
End Property
 
Private Property Get IObjectClassDescription_ModelNameUnique() As Boolean
  IObjectClassDescription_ModelNameUnique = False
End Property
 
Private Property Get IObjectClassDescription_InstanceCLSID() As esriSystem.IUID
  Dim pUID As esriSystem.IUID
  Set pUID = New UID
  pUID.Value = "esriGeoDatabase.Feature"
  Set IObjectClassDescription_InstanceCLSID = pUID
End Property
 
Private Property Get IObjectClassDescription_ClassExtensionCLSID() As esriSystem.IUID
  Dim pUID As esriSystem.IUID
  Set pUID = New UID
  pUID.Value = "TimestamperVB.TimestampClassExtension"
  Set IObjectClassDescription_ClassExtensionCLSID = pUID
End Property
 
Private Property Get IObjectClassDescription_RequiredFields() As esriGeoDatabase.IFields
  
  ' Get the required fields for a feature class, then add the timestamp fields
  Dim pOCDescription As IObjectClassDescription
  Set pOCDescription = New esriGeoDatabase.FeatureClassDescription
  Dim pFieldsEdit As IFieldsEdit
  Set pFieldsEdit = pOCDescription.RequiredFields

  ' Now add the timestamp fields
  Call basUtil.AddTimestampFields(pFieldsEdit)

  Set IObjectClassDescription_RequiredFields = pFieldsEdit
End Property
 
Private Property Get IFeatureClassDescription_FeatureType() As esriGeoDatabase.esriFeatureType
  IFeatureClassDescription_FeatureType = esriFTSimple
End Property
 
Private Property Get IFeatureClassDescription_ShapeFieldName() As String
  IFeatureClassDescription_ShapeFieldName = c_sShapeFieldName
End Property
