/*
 Copyright 1995-2004 ESRI

 All rights reserved under the copyright laws of the United States.

 You may freely redistribute and use this sample code, with or without modification.

 Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED 
 WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR 
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY 
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY 
 WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.

 For additional information contact: Environmental Systems Research Institute, Inc.

 Attn: Contracts Dept.

 380 New York Street

 Redlands, California, U.S.A. 92373 

 Email: contracts@esri.com
*/
// TimestampClassExtension.h : Declaration of the CTimestampClassExtension

#ifndef __TIMESTAMPCLASSEXTENSION_H_
#define __TIMESTAMPCLASSEXTENSION_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTimestampClassExtension
class ATL_NO_VTABLE CTimestampClassExtension : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTimestampClassExtension, &CLSID_TimestampClassExtension>,
	public ISupportErrorInfo,
	public ITimestampClassExtension,
	public IClassExtension,
	public IObjectClassEvents,
	public IObjectClassExtension
{
public:
	CTimestampClassExtension()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TIMESTAMPCLASSEXTENSION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_CATEGORY_MAP(CTimestampClassExtension)
	IMPLEMENTED_CATEGORY(__uuidof(CATID_GeoObjectClassExtensions))
END_CATEGORY_MAP()

BEGIN_COM_MAP(CTimestampClassExtension)
	COM_INTERFACE_ENTRY(ITimestampClassExtension)
	COM_INTERFACE_ENTRY(IClassExtension)
	COM_INTERFACE_ENTRY(IObjectClassEvents)
	COM_INTERFACE_ENTRY(IObjectClassExtension)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()


public:

// ITimestampClassExtension
	STDMETHOD(get_CreationFieldName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_CreationFieldName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_UserFieldName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_UserFieldName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_ModificationFieldName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ModificationFieldName)(/*[in]*/ BSTR newVal);
	STDMETHOD(UpdateProperties)();

	// IClassExtension
	STDMETHOD(Init)(IClassHelper * pClassHelper, IPropertySet * pExtensionProperties);
	STDMETHOD(Shutdown)();
// IObjectClassEvents
	STDMETHOD(OnCreate)(IObject * obj);
	STDMETHOD(OnDelete)(IObject * obj);
	STDMETHOD(OnChange)(IObject * obj);
// IObjectClassExtension
// ISupportErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
private:
	HRESULT TryDefaultProperties();
	HRESULT GetFieldPositions();
  HRESULT GetTimestamp(DATE *dtimestamp);
  HRESULT GetUsrName(BSTR *sUserName);

	IClassHelperPtr m_ipClassHelper;
	CComBSTR m_sCreFieldName;
	CComBSTR m_sModFieldName;
	CComBSTR m_sUsrFieldName;
	long m_lCreField;
	long m_lModField;
	long m_lUsrField;
	CComVariant m_vUsrName;
};

#endif //__TIMESTAMPCLASSEXTENSION_H_
